/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include "quakedef.h"
#include "gpsoundbuf.h"

int snd_inited;

unsigned int * soundPos;
volatile int idx_buf;

/*
==================
S_BlockSound
==================
*/
void S_BlockSound (void)
{
  GpPcmRemove((unsigned short*)shm->buffer);
}


/*
==================
S_UnblockSound
==================
*/
void S_UnblockSound (void)
{
  GpPcmPlay ( (unsigned short*)shm->buffer, 32768  , 1 );
}


/*
==================
FreeSound
==================
*/
void FreeSound (void)
{
  GpPcmStop();
}


qboolean SNDDMA_Init(void)
{
    
  GpPcmInit(PCM_M11,PCM_8BIT);
	GpPcmPlay ( (unsigned short*)shm->buffer, 32768  , 1 );
	GpPcmLock ( (unsigned short*)shm->buffer, (int*)&idx_buf, (unsigned int*)&soundPos );

	/*
	int size;

	size = 16384 + sizeof(dma_t);
	shm = gm_malloc (size);
	memset((void*)shm, 0, size);

	shm->splitbuffer = 0;
	shm->soundalive = true;
	shm->submission_chunk = 1;
	shm->channels=1;
	shm->samplebits=8;
	shm->speed=11025;
	shm->submission_chunk = 1;
	shm->samples=sizeof(RingBuf);
	shm->buffer=(unsigned char *)RingBuf;
	*/
    snd_inited = 1;

	return true;
}

/*
==============
SNDDMA_GetDMAPos

return the current sample position (in mono samples read)
inside the recirculating dma buffer, so the mixing code will know
how many sample are required to fill it up.
===============
*/
int SNDDMA_GetDMAPos(void)
{
  if (!snd_inited)
    return 0;

  if (soundPos==NULL)
    return 0;

  return *soundPos-(int)shm->buffer;
}

/*
==============
SNDDMA_Submit

Send sound to device if buffer isn't really the dma buffer
===============
*/
void SNDDMA_Submit(void)
{

}

/*
==============
SNDDMA_Shutdown

Reset the sound device for exiting
===============
*/
void SNDDMA_Shutdown(void)
{
	FreeSound ();
}

